## ros-crystal-rcl 0.6.6

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(rcl)

find_package(ament_cmake_ros REQUIRED)

find_package(rcl_interfaces REQUIRED)
find_package(rcutils REQUIRED)
find_package(rmw REQUIRED)
find_package(rmw_implementation REQUIRED)
find_package(rosidl_generator_c REQUIRED)

include_directories(include)

include(cmake/get_default_rcl_logging_implementation.cmake)
get_default_rcl_logging_implementation(RCL_LOGGING_IMPL)

# Default to C11
if(NOT CMAKE_C_STANDARD)
  set(CMAKE_C_STANDARD 11)
endif()

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra)
endif()

set(${PROJECT_NAME}_sources
  src/rcl/arguments.c
  src/rcl/client.c
  src/rcl/common.c
  src/rcl/context.c
  src/rcl/expand_topic_name.c
  src/rcl/graph.c
  src/rcl/guard_condition.c
  src/rcl/init.c
  src/rcl/init_options.c
  src/rcl/lexer.c
  src/rcl/lexer_lookahead.c
  src/rcl/logging_rosout.c
  src/rcl/logging.c
  src/rcl/node.c
  src/rcl/publisher.c
  src/rcl/remap.c
  src/rcl/rmw_implementation_identifier_check.c
  src/rcl/service.c
  src/rcl/subscription.c
  src/rcl/time.c
  src/rcl/timer.c
  src/rcl/validate_topic_name.c
  src/rcl/wait.c
)

add_library(${PROJECT_NAME} ${${PROJECT_NAME}_sources})
# specific order: dependents before dependencies
ament_target_dependencies(${PROJECT_NAME}
  "rcl_interfaces"
  "rmw_implementation"
  "rmw"
  "rcutils"
  "rosidl_generator_c"
  ${RCL_LOGGING_IMPL}
)

# Causes the visibility macros to use dllexport rather than dllimport,
# which is appropriate when building the dll but not consuming it.
target_compile_definitions(${PROJECT_NAME} PRIVATE "RCL_BUILDING_DLL")

install(
  TARGETS ${PROJECT_NAME}
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin)

# rcl_lib_dir is passed as APPEND_LIBRARY_DIRS for each ament_add_gtest call so
# the librcl that they link against is on the library path.
# This is especially important on Windows.
# This is overwritten each loop, but which one it points to doesn't really matter.
set(rcl_lib_dir "$<TARGET_FILE_DIR:${PROJECT_NAME}>")

# specific order: dependents before dependencies
ament_export_include_directories(include)
ament_export_libraries(${PROJECT_NAME})

ament_export_dependencies(ament_cmake)
ament_export_dependencies(rcl_interfaces)
ament_export_dependencies(rmw_implementation)
ament_export_dependencies(rmw)
ament_export_dependencies(rcutils)
ament_export_dependencies(rosidl_generator_c)
ament_export_dependencies(${RCL_LOGGING_IMPL})

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  ament_lint_auto_find_test_dependencies()

  add_subdirectory(test)
endif()

ament_package()

install(
  DIRECTORY include/
  DESTINATION include
)

=== test/CMakeLists.txt ===
find_package(ament_cmake_gtest REQUIRED)
find_package(ament_cmake_pytest REQUIRED)

find_package(test_msgs REQUIRED)

find_package(rmw_implementation_cmake REQUIRED)

find_package(osrf_testing_tools_cpp REQUIRED)

get_target_property(memory_tools_ld_preload_env_var
  osrf_testing_tools_cpp::memory_tools LIBRARY_PRELOAD_ENVIRONMENT_VARIABLE)

include(cmake/rcl_add_custom_executable.cmake)
include(cmake/rcl_add_custom_gtest.cmake)
include(cmake/rcl_add_custom_launch_test.cmake)

set(extra_lib_dirs "${rcl_lib_dir}")

# finding gtest once in the highest scope
# prevents finding it repeatedly in each local scope
ament_find_gtest()

macro(test_target)
  find_package(${rmw_implementation} REQUIRED)
  test_target_function()
endmacro()

function(test_target_function)
  message(STATUS "Creating tests for '${rmw_implementation}'")
  set(rmw_implementation_env_var RMW_IMPLEMENTATION=${rmw_implementation})

  # Gtests

  rcl_add_custom_gtest(test_client${target_suffix}
    SRCS rcl/test_client.cpp
    INCLUDE_DIRS ${osrf_testing_tools_cpp_INCLUDE_DIRS}
    ENV ${rmw_implementation_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    LIBRARIES ${PROJECT_NAME}
    AMENT_DEPENDENCIES ${rmw_implementation} "test_msgs"
  )

  rcl_add_custom_gtest(test_time${target_suffix}
    SRCS rcl/test_time.cpp
    ENV ${rmw_implementation_env_var} ${memory_tools_ld_preload_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    LIBRARIES ${PROJECT_NAME} osrf_testing_tools_cpp::memory_tools
    AMENT_DEPENDENCIES ${rmw_implementation}
  )

  rcl_add_custom_gtest(test_common${target_suffix}
    SRCS rcl/test_common.cpp
    ENV
      ${rmw_implementation_env_var}
      EMPTY_TEST=
      NORMAL_TEST=foo
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    LIBRARIES ${PROJECT_NAME}
    AMENT_DEPENDENCIES ${rmw_implementation}
  )

  rcl_add_custom_gtest(test_context${target_suffix}
    SRCS rcl/test_context.cpp
    ENV ${rmw_implementation_env_var} ${memory_tools_ld_preload_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    LIBRARIES ${PROJECT_NAME} osrf_testing_tools_cpp::memory_tools
    AMENT_DEPENDENCIES ${rmw_implementation}
  )

  rcl_add_custom_gtest(test_get_node_names${target_suffix}
    SRCS rcl/test_get_node_names.cpp
    INCLUDE_DIRS ${osrf_testing_tools_cpp_INCLUDE_DIRS}
    ENV ${rmw_implementation_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    LIBRARIES ${PROJECT_NAME}
    AMENT_DEPENDENCIES ${rmw_implementation}
  )

  rcl_add_custom_gtest(test_lexer${target_suffix}
    SRCS rcl/test_lexer.cpp
    ENV ${rmw_implementation_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    LIBRARIES ${PROJECT_NAME}
    AMENT_DEPENDENCIES ${rmw_implementation}
  )

  rcl_add_custom_gtest(test_lexer_lookahead${target_suffix}
    SRCS rcl/test_lexer_lookahead.cpp
    INCLUDE_DIRS ${osrf_testing_tools_cpp_INCLUDE_DIRS}
    ENV ${rmw_implementation_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    LIBRARIES ${PROJECT_NAME}
    AMENT_DEPENDENCIES ${rmw_implementation}
  )

  set(AMENT_GTEST_ARGS "")
  # TODO(wjwwood): remove this when the graph API works properly for connext dynamic
  if(rmw_implementation STREQUAL "rmw_connext_dynamic_cpp")
    message(STATUS "Skipping test_graph${target_suffix} test.")
    set(AMENT_GTEST_ARGS "SKIP_TEST")
  # TODO(mm318): why rmw_connext tests run much slower than rmw_fastrtps and rmw_opensplice tests
  elseif(rmw_implementation STREQUAL "rmw_connext_cpp")
    message(STATUS "Increasing test_graph${target_suffix} test timeout.")
    set(AMENT_GTEST_ARGS TIMEOUT 90)
  endif()
  rcl_add_custom_gtest(test_graph${target_suffix}
    SRCS rcl/test_graph.cpp
    INCLUDE_DIRS ${osrf_testing_tools_cpp_INCLUDE_DIRS}
    ENV ${rmw_implementation_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    LIBRARIES ${PROJECT_NAME}
    AMENT_DEPENDENCIES ${rmw_implementation} "test_msgs"
    ${AMENT_GTEST_ARGS}
  )

  rcl_add_custom_gtest(test_count_matched${target_suffix}
    SRCS rcl/test_count_matched.cpp
    INCLUDE_DIRS ${osrf_testing_tools_cpp_INCLUDE_DIRS}
    ENV ${rmw_implementation_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    LIBRARIES ${PROJECT_NAME}
    AMENT_DEPENDENCIES ${rmw_implementation} "test_msgs"
  )

  rcl_add_custom_gtest(test_init${target_suffix}
    SRCS rcl/test_init.cpp
    ENV ${rmw_implementation_env_var} ${memory_tools_ld_preload_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    LIBRARIES ${PROJECT_NAME} osrf_testing_tools_cpp::memory_tools
    AMENT_DEPENDENCIES ${rmw_implementation}
  )

  rcl_add_custom_gtest(test_node${target_suffix}
    SRCS rcl/test_node.cpp
    INCLUDE_DIRS ${osrf_testing_tools_cpp_INCLUDE_DIRS}
    ENV ${rmw_implementation_env_var} ${memory_tools_ld_preload_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    LIBRARIES ${PROJECT_NAME} osrf_testing_tools_cpp::memory_tools
    AMENT_DEPENDENCIES ${rmw_implementation}
  )

  rcl_add_custom_gtest(test_arguments${target_suffix}
    SRCS rcl/test_arguments.cpp
    ENV ${rmw_implementation_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    LIBRARIES ${PROJECT_NAME}
  )

  rcl_add_custom_gtest(test_remap${target_suffix}
    SRCS rcl/test_remap.cpp
    INCLUDE_DIRS ${osrf_testing_tools_cpp_INCLUDE_DIRS}
    ENV ${rmw_implementation_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    LIBRARIES ${PROJECT_NAME}
  )

  rcl_add_custom_gtest(test_remap_integration${target_suffix}
    SRCS rcl/test_remap_integration.cpp
    INCLUDE_DIRS ${osrf_testing_tools_cpp_INCLUDE_DIRS}
    TIMEOUT 200
    ENV ${rmw_implementation_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    LIBRARIES ${PROJECT_NAME}
    AMENT_DEPENDENCIES "test_msgs"
  )

  rcl_add_custom_gtest(test_guard_condition${target_suffix}
    SRCS rcl/test_guard_condition.cpp
    INCLUDE_DIRS ${osrf_testing_tools_cpp_INCLUDE_DIRS}
    ENV ${rmw_implementation_env_var} ${memory_tools_ld_preload_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    LIBRARIES ${PROJECT_NAME} osrf_testing_tools_cpp::memory_tools
    AMENT_DEPENDENCIES ${rmw_implementation}
  )

  rcl_add_custom_gtest(test_publisher${target_suffix}
    SRCS rcl/test_publisher.cpp
    INCLUDE_DIRS ${osrf_testing_tools_cpp_INCLUDE_DIRS}
    ENV ${rmw_implementation_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    LIBRARIES ${PROJECT_NAME}
    AMENT_DEPENDENCIES ${rmw_implementation} "test_msgs"
  )

  rcl_add_custom_gtest(test_service${target_suffix}
    SRCS rcl/test_service.cpp
    INCLUDE_DIRS ${osrf_testing_tools_cpp_INCLUDE_DIRS}
    ENV ${rmw_implementation_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    LIBRARIES ${PROJECT_NAME}
    AMENT_DEPENDENCIES ${rmw_implementation} "test_msgs"
  )

  rcl_add_custom_gtest(test_subscription${target_suffix}
    SRCS rcl/test_subscription.cpp
    INCLUDE_DIRS ${osrf_testing_tools_cpp_INCLUDE_DIRS}
    ENV ${rmw_implementation_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    LIBRARIES ${PROJECT_NAME}
    AMENT_DEPENDENCIES ${rmw_implementation} "test_msgs"
  )

  rcl_add_custom_gtest(test_wait${target_suffix}
    SRCS rcl/test_wait.cpp
    INCLUDE_DIRS ${osrf_testing_tools_cpp_INCLUDE_DIRS}
    ENV ${rmw_implementation_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    LIBRARIES ${PROJECT_NAME}
    AMENT_DEPENDENCIES ${rmw_implementation}
  )

  rcl_add_custom_gtest(test_namespace${target_suffix}
    SRCS test_namespace.cpp
    INCLUDE_DIRS ${osrf_testing_tools_cpp_INCLUDE_DIRS}
    ENV ${rmw_implementation_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    LIBRARIES ${PROJECT_NAME}
    AMENT_DEPENDENCIES ${rmw_implementation} "test_msgs"
  )

  # Launch tests

  rcl_add_custom_executable(service_fixture${target_suffix}
    SRCS rcl/service_fixture.cpp
    INCLUDE_DIRS ${osrf_testing_tools_cpp_INCLUDE_DIRS}
    LIBRARIES ${PROJECT_NAME}
    AMENT_DEPENDENCIES ${rmw_implementation} "test_msgs"
  )

  rcl_add_custom_executable(client_fixture${target_suffix}
    SRCS rcl/client_fixture.cpp
    INCLUDE_DIRS ${osrf_testing_tools_cpp_INCLUDE_DIRS}
    LIBRARIES ${PROJECT_NAME}
    AMENT_DEPENDENCIES ${rmw_implementation} "test_msgs"
  )

  rcl_add_custom_launch_test(test_services
    service_fixture
    client_fixture
    ENV ${rmw_implementation_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    TIMEOUT 15
  )

  set(SKIP_TEST "")
  if(WIN32)
    # TODO(dhood): launch does not set the return code correctly for these tests on Windows.
    # See https://github.com/ros2/launch/issues/66
    set(SKIP_TEST "SKIP_TEST")
  endif()
  set(TEST_RMW_IMPL_ID_CHECK_EXECUTABLE_NAME "$<TARGET_FILE:test_rmw_impl_id_check_exe>")
  configure_file(
    rcl/test_rmw_impl_id_check.py.in
    ${CMAKE_CURRENT_BINARY_DIR}/test_rmw_impl_id_check${target_suffix}.py.configure
    @ONLY
  )
  file(GENERATE
    OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/test/test_rmw_impl_id_check${target_suffix}_$<CONFIG>.py"
    INPUT "${CMAKE_CURRENT_BINARY_DIR}/test_rmw_impl_id_check${target_suffix}.py.configure"
  )
  ament_add_pytest_test(
    test_rmw_impl_id_check${target_suffix}
    "${CMAKE_CURRENT_BINARY_DIR}/test/test_rmw_impl_id_check${target_suffix}_$<CONFIG>.py"
    APPEND_LIBRARY_DIRS "${extra_lib_dirs}"
    ${SKIP_TEST}
  )
  if(TEST test_rmw_impl_id_check${target_suffix})
    set_tests_properties(
      test_rmw_impl_id_check${target_suffix}
      PROPERTIES DEPENDS test_rmw_impl_id_check_exe
    )
  endif()

endfunction()

# Build simple executable for using in the test_rmw_impl_id_check
add_executable(test_rmw_impl_id_check_exe
  rcl/test_rmw_impl_id_check_exe.cpp)
target_link_libraries(test_rmw_impl_id_check_exe ${PROJECT_NAME})

call_for_each_rmw_implementation(test_target)

rcl_add_custom_gtest(test_validate_topic_name
  SRCS rcl/test_validate_topic_name.cpp
  APPEND_LIBRARY_DIRS ${extra_lib_dirs}
  LIBRARIES ${PROJECT_NAME}
)

rcl_add_custom_gtest(test_expand_topic_name
  SRCS rcl/test_expand_topic_name.cpp
  APPEND_LIBRARY_DIRS ${extra_lib_dirs}
  LIBRARIES ${PROJECT_NAME}
)

rcl_add_custom_gtest(test_timer${target_suffix}
  SRCS rcl/test_timer.cpp
  INCLUDE_DIRS ${osrf_testing_tools_cpp_INCLUDE_DIRS}
  APPEND_LIBRARY_DIRS ${extra_lib_dirs}
  LIBRARIES ${PROJECT_NAME}
)

=== debian/changelog ===
ros-crystal-rcl (0.6.6-1bionic) bionic; urgency=high

  * Fix leak in __wait_set_clean_up. (#418 <https://github.com/ros2/rcl/issues/418>) (#486 <https://github.com/ros2/rcl/issues/486>)
  * Contributors: Dirk Thomas, Steven! Ragnarök

 -- William Woodall <william@osrfoundation.org>  Sat, 17 Aug 2019 07:00:00 -0000

ros-crystal-rcl (0.6.5-1bionic) bionic; urgency=high

  * Changed error to warning when loggers are created for nodes non-unique names.(#385 <https://github.com/ros2/rcl/issues/385>)
    * Backported by #384 <https://github.com/ros2/rcl/issues/384> for Crystal.
  * Removed test circumvention now that a bug is fixed in rmw_opensplice. (#386 <https://github.com/ros2/rcl/issues/386>)
    * Backported by #368 <https://github.com/ros2/rcl/issues/368> for Crystal.
  * Publish logs to Rosout (#350 <https://github.com/ros2/rcl/issues/350>)
  * Contributors: Nick Burek, Steven! Ragnarök

 -- William Woodall <william@osrfoundation.org>  Fri, 08 Feb 2019 08:00:00 -0000

ros-crystal-rcl (0.6.4-1bionic) bionic; urgency=high

  * Added method for accessing rmw_context from rcl_context (#372 <https://github.com/ros2/rcl/issues/372>)
  * Added guard against bad allocation when calling rcl_arguments_copy() (#367 <https://github.com/ros2/rcl/issues/367>)
  * Updated to ensure that context instance id storage is aligned correctly (#365 <https://github.com/ros2/rcl/issues/365>)
  * Fixed error from uncrustify v0.68 (#364 <https://github.com/ros2/rcl/issues/364>)
  * Contributors: Jacob Perron, William Woodall, sgvandijk

 -- William Woodall <william@osrfoundation.org>  Fri, 11 Jan 2019 08:00:00 -0000

ros-crystal-rcl (0.6.3-1bionic) bionic; urgency=high

  * Set rmw_wait timeout using ros timers too (#357 <https://github.com/ros2/rcl/issues/357>)
  * Contributors: Shane Loretz

 -- William Woodall <william@osrfoundation.org>  Thu, 13 Dec 2018 08:00:00 -0000

ros-crystal-rcl (0.6.2-1bionic) bionic; urgency=high

  * Updated docs about possibility of rcl_take not taking (#356 <https://github.com/ros2/rcl/issues/356>)
  * Bugfix: ensure NULL timeout is passed to rmw_wait() when min_timeout is not set
    Otherwise, there is a risk of integer overflow (e.g. in rmw_fastrtps) and rmw_wait() will wake immediately.
  * Contributors: Jacob Perron, William Woodall

 -- William Woodall <william@osrfoundation.org>  Thu, 13 Dec 2018 08:00:00 -0000

ros-crystal-rcl (0.6.1-1bionic) bionic; urgency=high

  * Added new cli parameters for configuring the logging. (#327 <https://github.com/ros2/rcl/issues/327>)
  * Added node graph api to rcl. (#333 <https://github.com/ros2/rcl/issues/333>)
  * Fixed compiler warning in clang (#345 <https://github.com/ros2/rcl/issues/345>)
  * Refactored init to not be global (#336 <https://github.com/ros2/rcl/issues/336>)
  * Methods to retrieve matched counts on pub/sub. (#326 <https://github.com/ros2/rcl/issues/326>)
  * Updated to output index in container when adding an entity to a wait set. (#335 <https://github.com/ros2/rcl/issues/335>)
  * Contributors: Jacob Perron, Michael Carroll, Nick Burek, Ross Desmond, William Woodall

 -- William Woodall <william@osrfoundation.org>  Fri, 07 Dec 2018 08:00:00 -0000

ros-crystal-rcl (0.6.0-1bionic) bionic; urgency=high

  * Updated to expand node_secure_root using local_namespace (#300 <https://github.com/ros2/rcl/issues/300>)
  * Moved stdatomic helper to rcutils (#324 <https://github.com/ros2/rcl/issues/324>)
  * Added subfolder argument to the ROSIDL_GET_SRV_TYPE_SUPPORT macro (#322 <https://github.com/ros2/rcl/issues/322>)
  * Updated to use new error handling API from rcutils (#314 <https://github.com/ros2/rcl/issues/314>)
  * Fixed minor documentation issues (#305 <https://github.com/ros2/rcl/issues/305>)
  * Added macro semicolons (#303 <https://github.com/ros2/rcl/issues/303>)
  * Added Rcl timer with ros time (#286 <https://github.com/ros2/rcl/issues/286>)
  * Updated to ensure that timer period is non-negative (#295 <https://github.com/ros2/rcl/issues/295>)
  * Fixed calculation of next timer call (#291 <https://github.com/ros2/rcl/issues/291>)
  * Updated to null deallocated jump callbacks (#294 <https://github.com/ros2/rcl/issues/294>)
  * Included namespaces in get_node_names. (#287 <https://github.com/ros2/rcl/issues/287>)
  * Fixed documentation issues (#288 <https://github.com/ros2/rcl/issues/288>)
  * Updated to check if pointers are null before calling memset (#290 <https://github.com/ros2/rcl/issues/290>)
  * Added multiple time jump callbacks to clock (#284 <https://github.com/ros2/rcl/issues/284>)
  * Consolidated wait set functions (#285 <https://github.com/ros2/rcl/issues/285>)
    * Consolidate functions to clear wait set
    Added rcl_wait_set_clear()
    Added rcl_wait_set_resize()
    Removed
    rcl_wait_set_clear_subscriptions()
    rcl_wait_set_clear_guard_conditions()
    rcl_wait_set_clear_clients()
    rcl_wait_set_clear_services()
    rcl_wait_set_clear_timers()
    rcl_wait_set_resize_subscriptions()
    rcl_wait_set_resize_guard_conditions()
    rcl_wait_set_resize_timers()
    rcl_wait_set_resize_clients()
    rcl_wait_set_resize_services()
  * ROS clock storage initially set to zero (#283 <https://github.com/ros2/rcl/issues/283>)
  * Fixed issue with deallocation of parameter_files (#279 <https://github.com/ros2/rcl/issues/279>)
  * Update to initialize memory before sending a message (#277 <https://github.com/ros2/rcl/issues/277>)
  * Set error message when clock type is not ROS_TIME (#275 <https://github.com/ros2/rcl/issues/275>)
  * Copy allocator passed in to clock init (#274 <https://github.com/ros2/rcl/issues/274>)
  * Update to initialize timer with clock (#272 <https://github.com/ros2/rcl/issues/272>)
  * Updated to use test_msgs instead of std_msgs in tests (#270 <https://github.com/ros2/rcl/issues/270>)
  * Added regression test for node:__ns remapping (#263 <https://github.com/ros2/rcl/issues/263>)
  * Updated to support Uncrustify 0.67 (#266 <https://github.com/ros2/rcl/issues/266>)


=== debian/control ===
Source: ros-crystal-rcl
Section: misc
Priority: extra
Maintainer: William Woodall <william@osrfoundation.org>
Build-Depends: debhelper (>= 9.0.0), ros-crystal-ament-cmake-gtest, ros-crystal-ament-cmake-pytest, ros-crystal-ament-cmake-ros, ros-crystal-ament-lint-auto, ros-crystal-ament-lint-common, ros-crystal-launch, ros-crystal-osrf-testing-tools-cpp, ros-crystal-rcl-interfaces, ros-crystal-rcl-logging-noop, ros-crystal-rcutils, ros-crystal-rmw, ros-crystal-rmw-implementation, ros-crystal-rmw-implementation-cmake, ros-crystal-rosidl-generator-c, ros-crystal-test-msgs, ros-crystal-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-crystal-rcl
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-crystal-ament-cmake, ros-crystal-rcl-interfaces, ros-crystal-rcl-logging-noop, ros-crystal-rcutils, ros-crystal-rmw, ros-crystal-rmw-implementation, ros-crystal-rosidl-default-runtime, ros-crystal-rosidl-generator-c, ros-crystal-ros-workspace
Description: The ROS client library common implementation.
 This package contains an API which builds on the ROS middleware API and is optionally built upon by the other ROS client libraries.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/crystal/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/crystal/setup.sh" ]; then . "/opt/ros/crystal/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/crystal" \
		-DAMENT_PREFIX_PATH="/opt/ros/crystal"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/crystal/setup.sh" ]; then . "/opt/ros/crystal/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/crystal/setup.sh" ]; then . "/opt/ros/crystal/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/crystal/setup.sh" ]; then . "/opt/ros/crystal/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-crystal-rcl//opt/ros/crystal/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/crystal/setup.sh" ]; then . "/opt/ros/crystal/setup.sh"; fi && \
	dh_auto_install
